﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FScada.SDK;
using System.Diagnostics;
using System.Collections;

namespace Demo
{
    /// <summary>
    /// 
    /// </summary>
    public partial class MainForm : Form
    {
        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 
        /// </summary>
        List<ListViewItem> listitems = new List<ListViewItem>();
        /// <summary>
        /// 
        /// </summary>
        IOClient ioclient = new IOClient("localhost", "admin", "admin", 8020);

        private void Form1_Load(object sender, EventArgs e)
        {
            ioclient.Start();
            ioclient.TagsChanged += OnTagsChanged;            
        }


        private void OnTagsChanged(object o ,EventArgs e)
        {
            this.Invoke(new EventHandler(UpdateControl), new object[] { null, null });
        }

        private void UpdateControl(object o, EventArgs e)
        {           
            timer1.Enabled = false;            
            listView1.Items.Clear();
            if (ioclient.Conntectd)
            {
                lock (this)
                {
                    foreach (BaseChannel channel in ioclient.Channels)
                    {
                        ListViewItem lv = AddRow(channel.Name);
                        channel.Tag = lv;
                    }
                    timer1.Enabled = true;
                }
            }
        }

        private ListViewItem AddRow(string name)
        {
            ListViewItem lv = new ListViewItem(name);
            lv.SubItems.Add("");
            lv.SubItems.Add("");
            lv.SubItems.Add("");
            listView1.Items.Add(lv);
            return lv;
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {          

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (ioclient.Conntectd)
            {
                lock (this)
                {
                    if (ioclient.Wait(100))
                    {
                        listView1.BeginUpdate();
                        foreach (BaseChannel channel in ioclient.Channels)
                        {
                            if (channel.Tag != null)
                            {
                                ListViewItem lv = channel.Tag as ListViewItem;
                                lv.SubItems[1].Text = channel.strValue;
                                lv.SubItems[2].Text = channel.ValueUpdateTime.ToString();
                                lv.SubItems[3].Text = channel.StatusFlags.ToString();
                            }
                        }
                        listView1.EndUpdate();
                    }
                }
            }
            connLabel.Text = ioclient.Conntectd ? "已经链接" : "断开链接";
        }

        private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            ioclient.TagsChanged -= OnTagsChanged;
            ioclient.Stop();
        }
    }
}
